> For the complete documentation index, see [llms.txt](https://docs.ionos.com/cloud/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.ionos.com/cloud/api-reference/security/identity/models.md).

# Models

## The PasswordPolicyReadList object

```json
{"openapi":"3.0.3","info":{"title":"IONOS CLOUD - IAM Identity Password Policies API","version":"1.0.0"},"components":{"schemas":{"PasswordPolicyReadList":{"allOf":[{"type":"object","required":["id","type","href"],"properties":{"id":{"description":"ID of the list of PasswordPolicy resources.","type":"string","format":"uuid"},"type":{"description":"The type of the resource.","type":"string","enum":["collection"]},"href":{"description":"The URL of the list of PasswordPolicy resources.","type":"string"},"items":{"description":"The list of PasswordPolicy resources.","type":"array","items":{"$ref":"#/components/schemas/PasswordPolicyRead"}}}}]},"PasswordPolicyRead":{"type":"object","required":["id","type","href","metadata","properties"],"properties":{"id":{"type":"string","description":"The ID (UUID) of the PasswordPolicy.","format":"uuid"},"type":{"description":"The type of the resource.","type":"string","enum":["passwordpolicy"]},"href":{"description":"The URL of the PasswordPolicy.","type":"string"},"metadata":{"$ref":"#/components/schemas/Metadata"},"properties":{"$ref":"#/components/schemas/PasswordPolicy"}}},"Metadata":{"type":"object","description":"Metadata of the resource.","properties":{"createdDate":{"type":"string","format":"date-time","description":"The ISO 8601 creation timestamp.","readOnly":true},"createdBy":{"type":"string","description":"Unique name of the identity that created the resource.","readOnly":true},"createdByUserId":{"type":"string","description":"Unique id of the identity that created the resource.","readOnly":true},"lastModifiedDate":{"type":"string","format":"date-time","description":"The ISO 8601 modified timestamp.","readOnly":true},"lastModifiedBy":{"type":"string","description":"Unique name of the identity that last modified the resource.","readOnly":true},"lastModifiedByUserId":{"type":"string","description":"Unique id of the identity that last modified the resource.","readOnly":true},"resourceURN":{"type":"string","description":"Unique name of the resource.","readOnly":true}}},"PasswordPolicy":{"type":"object","required":["description","minLength"],"properties":{"description":{"type":"string","description":"Human readable description of the policy.","maxLength":1024},"minLength":{"description":"Minimum number characters","minimum":5,"type":"integer"},"minNumberChars":{"description":"Lower characters are considered to be all in range of [0-9]","type":"integer","default":0,"minimum":0},"minUpperChars":{"description":"Lower characters are considered to be all in range of [A-Z]","type":"integer","default":0,"minimum":0},"minLowerChars":{"description":"Lower characters are considered to be all in range of [a-z]","type":"integer","default":0,"minimum":0},"minSpecialChars":{"description":"Special characters are considered to be all characters that are not in the ASCII ranges [a-zA-Z0-9]","type":"integer","default":0,"minimum":0}}}}}}
```

## The PasswordPolicyRead object

```json
{"openapi":"3.0.3","info":{"title":"IONOS CLOUD - IAM Identity Password Policies API","version":"1.0.0"},"components":{"schemas":{"PasswordPolicyRead":{"type":"object","required":["id","type","href","metadata","properties"],"properties":{"id":{"type":"string","description":"The ID (UUID) of the PasswordPolicy.","format":"uuid"},"type":{"description":"The type of the resource.","type":"string","enum":["passwordpolicy"]},"href":{"description":"The URL of the PasswordPolicy.","type":"string"},"metadata":{"$ref":"#/components/schemas/Metadata"},"properties":{"$ref":"#/components/schemas/PasswordPolicy"}}},"Metadata":{"type":"object","description":"Metadata of the resource.","properties":{"createdDate":{"type":"string","format":"date-time","description":"The ISO 8601 creation timestamp.","readOnly":true},"createdBy":{"type":"string","description":"Unique name of the identity that created the resource.","readOnly":true},"createdByUserId":{"type":"string","description":"Unique id of the identity that created the resource.","readOnly":true},"lastModifiedDate":{"type":"string","format":"date-time","description":"The ISO 8601 modified timestamp.","readOnly":true},"lastModifiedBy":{"type":"string","description":"Unique name of the identity that last modified the resource.","readOnly":true},"lastModifiedByUserId":{"type":"string","description":"Unique id of the identity that last modified the resource.","readOnly":true},"resourceURN":{"type":"string","description":"Unique name of the resource.","readOnly":true}}},"PasswordPolicy":{"type":"object","required":["description","minLength"],"properties":{"description":{"type":"string","description":"Human readable description of the policy.","maxLength":1024},"minLength":{"description":"Minimum number characters","minimum":5,"type":"integer"},"minNumberChars":{"description":"Lower characters are considered to be all in range of [0-9]","type":"integer","default":0,"minimum":0},"minUpperChars":{"description":"Lower characters are considered to be all in range of [A-Z]","type":"integer","default":0,"minimum":0},"minLowerChars":{"description":"Lower characters are considered to be all in range of [a-z]","type":"integer","default":0,"minimum":0},"minSpecialChars":{"description":"Special characters are considered to be all characters that are not in the ASCII ranges [a-zA-Z0-9]","type":"integer","default":0,"minimum":0}}}}}}
```

## The PasswordPolicyEnsure object

```json
{"openapi":"3.0.3","info":{"title":"IONOS CLOUD - IAM Identity Password Policies API","version":"1.0.0"},"components":{"schemas":{"PasswordPolicyEnsure":{"type":"object","required":["id","properties"],"properties":{"id":{"type":"string","description":"The ID (UUID) of the PasswordPolicy.","format":"uuid"},"metadata":{"description":"Metadata","additionalProperties":true},"properties":{"$ref":"#/components/schemas/PasswordPolicy"}}},"PasswordPolicy":{"type":"object","required":["description","minLength"],"properties":{"description":{"type":"string","description":"Human readable description of the policy.","maxLength":1024},"minLength":{"description":"Minimum number characters","minimum":5,"type":"integer"},"minNumberChars":{"description":"Lower characters are considered to be all in range of [0-9]","type":"integer","default":0,"minimum":0},"minUpperChars":{"description":"Lower characters are considered to be all in range of [A-Z]","type":"integer","default":0,"minimum":0},"minLowerChars":{"description":"Lower characters are considered to be all in range of [a-z]","type":"integer","default":0,"minimum":0},"minSpecialChars":{"description":"Special characters are considered to be all characters that are not in the ASCII ranges [a-zA-Z0-9]","type":"integer","default":0,"minimum":0}}}}}}
```

## The PasswordPolicyCreate object

```json
{"openapi":"3.0.3","info":{"title":"IONOS CLOUD - IAM Identity Password Policies API","version":"1.0.0"},"components":{"schemas":{"PasswordPolicyCreate":{"type":"object","required":["properties"],"properties":{"metadata":{"description":"Metadata","additionalProperties":true},"properties":{"$ref":"#/components/schemas/PasswordPolicy"}}},"PasswordPolicy":{"type":"object","required":["description","minLength"],"properties":{"description":{"type":"string","description":"Human readable description of the policy.","maxLength":1024},"minLength":{"description":"Minimum number characters","minimum":5,"type":"integer"},"minNumberChars":{"description":"Lower characters are considered to be all in range of [0-9]","type":"integer","default":0,"minimum":0},"minUpperChars":{"description":"Lower characters are considered to be all in range of [A-Z]","type":"integer","default":0,"minimum":0},"minLowerChars":{"description":"Lower characters are considered to be all in range of [a-z]","type":"integer","default":0,"minimum":0},"minSpecialChars":{"description":"Special characters are considered to be all characters that are not in the ASCII ranges [a-zA-Z0-9]","type":"integer","default":0,"minimum":0}}}}}}
```

## The PasswordPolicy object

```json
{"openapi":"3.0.3","info":{"title":"IONOS CLOUD - IAM Identity Password Policies API","version":"1.0.0"},"components":{"schemas":{"PasswordPolicy":{"type":"object","required":["description","minLength"],"properties":{"description":{"type":"string","description":"Human readable description of the policy.","maxLength":1024},"minLength":{"description":"Minimum number characters","minimum":5,"type":"integer"},"minNumberChars":{"description":"Lower characters are considered to be all in range of [0-9]","type":"integer","default":0,"minimum":0},"minUpperChars":{"description":"Lower characters are considered to be all in range of [A-Z]","type":"integer","default":0,"minimum":0},"minLowerChars":{"description":"Lower characters are considered to be all in range of [a-z]","type":"integer","default":0,"minimum":0},"minSpecialChars":{"description":"Special characters are considered to be all characters that are not in the ASCII ranges [a-zA-Z0-9]","type":"integer","default":0,"minimum":0}}}}}}
```

## The Error object

```json
{"openapi":"3.0.3","info":{"title":"IONOS CLOUD - IAM Identity Password Policies API","version":"1.0.0"},"components":{"schemas":{"Error":{"description":"The Error object is used to represent an error response from the API.\n","type":"object","properties":{"httpStatus":{"type":"integer","description":"The HTTP status code of the operation."},"messages":{"type":"array","description":"A list of error messages.\n","items":{"type":"object","properties":{"errorCode":{"type":"string","description":"Application internal error code\n"},"message":{"type":"string","description":"A human readable explanation specific to this occurrence of the\nproblem.\n"}}}}}}}}}
```

## The Metadata object

```json
{"openapi":"3.0.3","info":{"title":"IONOS CLOUD - IAM Identity Password Policies API","version":"1.0.0"},"components":{"schemas":{"Metadata":{"type":"object","description":"Metadata of the resource.","properties":{"createdDate":{"type":"string","format":"date-time","description":"The ISO 8601 creation timestamp.","readOnly":true},"createdBy":{"type":"string","description":"Unique name of the identity that created the resource.","readOnly":true},"createdByUserId":{"type":"string","description":"Unique id of the identity that created the resource.","readOnly":true},"lastModifiedDate":{"type":"string","format":"date-time","description":"The ISO 8601 modified timestamp.","readOnly":true},"lastModifiedBy":{"type":"string","description":"Unique name of the identity that last modified the resource.","readOnly":true},"lastModifiedByUserId":{"type":"string","description":"Unique id of the identity that last modified the resource.","readOnly":true},"resourceURN":{"type":"string","description":"Unique name of the resource.","readOnly":true}}}}}}
```

## The Pagination object

```json
{"openapi":"3.0.3","info":{"title":"IONOS CLOUD - IAM Identity Password Policies API","version":"1.0.0"},"components":{"schemas":{"Pagination":{"required":["offset","limit","_links"],"description":"Pagination information. The offset and limit parameters are used to\nnavigate the list of elements. The _links object contains URLs to\nnavigate the different pages.\n","type":"object","properties":{"offset":{"$ref":"#/components/schemas/Offset"},"limit":{"$ref":"#/components/schemas/Limit"},"_links":{"$ref":"#/components/schemas/Links"}}},"Offset":{"description":"The offset specified in the request (if none was specified, the default\noffset is 0).\n","type":"integer","minimum":0,"readOnly":true},"Limit":{"description":"The limit specified in the request (if none was specified, use the\nendpoint's default pagination limit).\n","type":"integer","minimum":0,"readOnly":true},"Links":{"description":"URLs to navigate the different pages. As of now we always only return a\nsingle page.\n","type":"object","properties":{"prev":{"description":"URL (with offset and limit parameters) of the previous page; only\npresent if offset is greater than 0.\n","type":"string","format":"uri","readOnly":true},"self":{"description":"URL (with offset and limit parameters) of the current page.\n","type":"string","format":"uri","readOnly":true},"next":{"description":"URL (with offset and limit parameters) of the next page; only\npresent if offset + limit is less than the total number of elements.\n","type":"string","format":"uri","readOnly":true}}}}}}
```

## The Offset object

```json
{"openapi":"3.0.3","info":{"title":"IONOS CLOUD - IAM Identity Password Policies API","version":"1.0.0"},"components":{"schemas":{"Offset":{"description":"The offset specified in the request (if none was specified, the default\noffset is 0).\n","type":"integer","minimum":0,"readOnly":true}}}}
```

## The Limit object

```json
{"openapi":"3.0.3","info":{"title":"IONOS CLOUD - IAM Identity Password Policies API","version":"1.0.0"},"components":{"schemas":{"Limit":{"description":"The limit specified in the request (if none was specified, use the\nendpoint's default pagination limit).\n","type":"integer","minimum":0,"readOnly":true}}}}
```

## The Links object

```json
{"openapi":"3.0.3","info":{"title":"IONOS CLOUD - IAM Identity Password Policies API","version":"1.0.0"},"components":{"schemas":{"Links":{"description":"URLs to navigate the different pages. As of now we always only return a\nsingle page.\n","type":"object","properties":{"prev":{"description":"URL (with offset and limit parameters) of the previous page; only\npresent if offset is greater than 0.\n","type":"string","format":"uri","readOnly":true},"self":{"description":"URL (with offset and limit parameters) of the current page.\n","type":"string","format":"uri","readOnly":true},"next":{"description":"URL (with offset and limit parameters) of the next page; only\npresent if offset + limit is less than the total number of elements.\n","type":"string","format":"uri","readOnly":true}}}}}}
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.ionos.com/cloud/api-reference/security/identity/models.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
